package lsedit;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.UndoableEdit;

// Something with the smarts to paint itself specially

public class MyPaintableUndoableEdit extends MyUndoableEdit implements UndoableEdit {

	// Helper methods 

	protected void paintComponentColor(Graphics g, int x, int y, Color color)
	{
		String		s = getPresentationName();
		FontMetrics	fm;
		int			x1;
		Color		save;

		g.drawString(s, x, y+HistoryBox.BASELINE);
		fm    = g.getFontMetrics(HistoryBox.m_textFont);
		x1    = x + fm.stringWidth(s);
		if (color == null) {
			g.drawRect(x1, y+3, HistoryBox.HEIGHT-6, HistoryBox.HEIGHT-6);
		} else {
			save = g.getColor();
			g.setColor(color);
			g.fillRect(x1, y+3, HistoryBox.HEIGHT-6, HistoryBox.HEIGHT-6);
			g.setColor(save);
	}	}

	public int getPreferredWidthColor(LandscapeObject o)
	{
		FontMetrics	fm;

		fm   = o.getDiagram().getFontMetrics(HistoryBox.m_textFont);
		return(fm.stringWidth(getPresentationName()) + HistoryBox.HEIGHT);
	}

	public void paintComponent(Graphics g, int x, int y)
	{
	}

	public int getPreferredWidth()
	{
		return(0);
}	}

